import React from 'react';
import { BalanceFunctionType, BinaryTreeRefType, CheckTreeTypeFunctionType, ClearFunctionType, GenerateRandomTreeFunctionType, GetDataFunctionType, InsertFunctionType, RemoveFunctionType, SearchFunctionType } from '../types';
declare type UseTreeReturnType = {
    ref: React.MutableRefObject<BinaryTreeRefType>;
    insert: InsertFunctionType;
    remove: RemoveFunctionType;
    search: SearchFunctionType;
    getData: GetDataFunctionType;
    clear: ClearFunctionType;
    balance: BalanceFunctionType;
    generateRandomTree: GenerateRandomTreeFunctionType;
    checkTreeType: CheckTreeTypeFunctionType;
};
declare const useBinarySearchTree: () => UseTreeReturnType;
export default useBinarySearchTree;
