import React from 'react';
import { SelfBalancingTreeRefType, CheckTreeTypeFunctionType, ClearFunctionType, GenerateRandomTreeFunctionType, GetDataFunctionType, InsertFunctionType, RemoveFunctionType, SearchFunctionType } from '../types';
declare type UseTreeReturnType = {
    ref: React.MutableRefObject<SelfBalancingTreeRefType>;
    insert: InsertFunctionType;
    remove: RemoveFunctionType;
    search: SearchFunctionType;
    getData: GetDataFunctionType;
    clear: ClearFunctionType;
    generateRandomTree: GenerateRandomTreeFunctionType;
    checkTreeType: CheckTreeTypeFunctionType;
};
declare const useSelfBalancingTree: () => UseTreeReturnType;
export default useSelfBalancingTree;
