import { MutableRefObject } from 'react';
import { GenerateRandomTrieFunctionType, GetAllWordsFunctionTrieType, InsertFunctionTrieType, RemoveFunctionTrieType, RemoveHighlightTrieFunctionType, SearchFunctionTrieType, SearchPrefixFunctionTrieType, TrieRefType } from '../types';
declare type ReturnType = {
    ref: MutableRefObject<TrieRefType>;
    insert: InsertFunctionTrieType;
    remove: RemoveFunctionTrieType;
    search: SearchFunctionTrieType;
    searchPrefix: SearchPrefixFunctionTrieType;
    getAllWords: GetAllWordsFunctionTrieType;
    generateRandomTrie: GenerateRandomTrieFunctionType;
    removeHighlight: RemoveHighlightTrieFunctionType;
};
declare const useTrie: () => ReturnType;
export default useTrie;
